################################################################################
#INTRO
#How do you upload this on a web site for anyone to be able to play with it?

#How do you build in no-hyphenation so that a word doesn't get cut at the edge?
#How do you format the text?

#Can we run it on an S60?
#How does one jump functions in python?
#How to create a database of memories that can only be accessed wheh you are in a certain room
#How do you create an "OR" option without creating a list.
################################################################################

intro = """
They pushed your face into the muddy water. You had shut your eyes tight, in a vain attempt to disregard the sharp blades of paddy. Bubbles of air escaped your mouth. You gulped. And after what seemed like a lifetime, they pulled you back out. One hand held you tight by the hair, and the other held a knife across your throat.

'Tell us where the tunnels are!'
'I don't know sir', you whimpered.
'You think you can get away with lies? You f***** Charlie!'
And they pushed you back into the water.

They were about to kill you. One slash of knife and it would've all been over. But then, he walked into the camp.
'Untie him. Let him go.'
'You know what you're saying Mat? He's a freakin' Charlie!'
'He's not. I've seen him in the adjoining village. Plus, he's a kid.'

And so you were alive. And free.
But the war in Vietnam had only begun.
"""
title ="---------------- PADDY FIELDS -----------------"
byline = "An Interactive Fiction for newbies\nA Major Studio project by Shipra Gupta\n(For more in interactive fiction, type HELP)\n(For history of Vietnam War, type HISTORY)"
endline = "----------------------------------------------"

################################################################################
#HISTORY TEXT
################################################################################
why = "WHY VIETNAM WAR? ITS BEEN DONE TO DEATH!\nDuring my tenure with Dorling Kindersley, a publishing house, I was working on the Eyewitness guide to Vietnam. Thus by default, I read about the various aspects of the country, and saw a lot of photographs, to be able to visualize a story idea. I had started work on a story while still an employee at the office. I reworked the abandoned draft for this project."


soldiers = "THE SOLDIERS:\n\nVIET CONG:\nThe National Front for the Liberation of South Vietnam was commonly known as the 'Viet Cong'. The Americans code named their millitary group, 'Charlie'. The VC supported the North's communist NLF (led by Ho Chi Minh), during the Vietnam War. This made them enemies of fellow countrymen who were allied to the South Vietnamese state.\n\nUS MARINES:\nThe United States army sent to ally with the South Vietnamese government. if situation permitted, they evacuated locals from an area before any battle could ensue. Their challenges in southern territory included - the tropical climate - VC guerilla tactics that included tunnel warfare and booby traps - inability to distinguish between VC and South Vietnamese locals.\n\nDIGGERS:\nThe Australian army sent to ally with US Marines. They were well known for being excellent 'tunnel rats' (men who searched the VC tunnels), and won the famous battle of Long Tan.\n\nLOCALS:\nSouth Vietnamese locals may or may not have sided with their government. if lucky, the marines would leave them alone. If unlucky, they were misunderstood as VC by marines, or killed by the VC themselves to generate terror and illicit support for the North's cause."

cloth = "THE STORY CLOTH:\nThe story cloth relates to the HMONG, a North Vietnamese ethnic people (also found in China, Laos, Thailand and Myanmmar). They are renowned for their skillful and intricate embroidery.\n\nSome claim that Hmong made 'story cloths', an embroidered record of tales, through patterns that symbolized the sounds of their ancient language (now forgotten). Others assert, that this in-fact, is untrue. According to them, the Vietnam War refugees in Indonesia crated story cloths for economic sustenance."

war = "THE WAR:\nThe Vietnam War started as a civil war between the communist North Vietnam and the anti-comunist South Vietnam. The South Vietnamese army was aided by 'marines', another name for the troops of United States.\n\nBackground:\nVietnam was a french colony. After the first Indo-China war, the french were overthrown. The resulting Geneva conference divided Vietnam into two factions - communist North and anti-communist South. Unification of the two was to occur through supervised elections. Diem, the ruling president of South Vietnam opposed the elections. This led to civil war in which the South was aided by the US forces. The war escalated due to increasing US involvement."

################################################################################
#GLOBAL DECLARATIONS
################################################################################
import sys
import random

#THE GAME
def startgame():
	hideInBasket()
	homeAlone()
	courtyard()
	fields()
	
#SYSTEM EXIT
def over():
	print endline
	print "**GAME OVER**"
	sys.exit()

#COMMAND LINE
def command():
	global input 
	input = raw_input("--> ")

def space():
	global input 
	input = raw_input("\nspace + enter--> ")


		


def help():
	print endline
	print "\nNEW TO INTERACTIVE FICTION? NO WORRIES!\nInteractive fiction is a genre of story-telling/ game playing which takes the player through a story with many paths and endings. Sometimes a player maybe scored for the best possible path taken through puzzle-solving.\n\nThis interactive fiction is really user friendly. It'll allow you to navigate the story without frustrating you with puzzles or word guessing games. There will be enough menus to choose your path from, and obvious hints floating about to feed into a commandline.\n\nWHAT YOU NEED TO OBSERVE:\n The action-person OR action-object sequences to produce a response from the story. For example, 'attack Vietcong' or 'hear Vietcong' will make your player character attack the Vietcong (a non-player character) or hear him.\n\nMy text here tries to, but doesn't neccessarily follow the action-noun policy strictly, so that my narrative here is not ripped apart. But it'll give you the general idea anyhow. Also note, how directions enable back and forth movement through the game.\n\nAfter Playing this piece, you could try playing ZORK. Its an early Infocom piece, a classic icon of all things Interactive Fiction!\n\nNow sit back, and bon voyage through the PADDY FIELDS!"
	print endline
	
def history():
	print endline
	print "\nWHAT WOULD YOU LIKE TO KNOW ABOUT IN HISTORY?\n1: THE VIETNAM WAR\n2: THE SOLDIERS\n3: THE STORYCLOTH\n4: WHY VIETNAM WAR?"
	
	lookup = int(raw_input("--> "))
	print endline
	if lookup == 1:
		print war
	
	elif lookup == 2:
		print soldiers
	
	elif lookup == 3:
		print cloth
	
	elif lookup == 4:
		print why
	print endline
		

#PEOPLE IN THE GAME	
#personlist = ['parents', 'mother', 'father', 'mom', 'dad', 'vietcong', #'soldier', 'mat']

#THINGS IN THE GAME
#thinglist = ['gun', 'basket'

#ACTION VERBS IN THE GAME
#verblist = ['think', 'examine', 'x', 'hear', 'ask', 'tell', 'getin', 'getout', #'up', 'down']






################################################################################
#ROOM DESCRIPTIONS
################################################################################
hideInBasketDescript = "HIDING IN THE WICKER BASKET\n\n'No!'\nThe shock is silent.\n\nThrough tiny spaces in the large wicker basket, you watch your parents fall. The death is quick and painless. The VietCong enter your hut with heavy guns. Their lean but strong bodies are tense, on a look-out for enemy. They tear your home down  while you watch, powerless."

homeAloneDescript = "\nALONE IN THE VILLAGE HUT\nFor a long time you crouch beneath the basket. Waiting. Fires rage beyond the thatch walls. You hear the neighbors scream. You imagine them huddled, clutching one another as each is snatched, searched and shot. They couldn't be spies, or could they? Did mom and dad spy on the VietCong?\n\nYou think about your PARENTS."

courtyardDescript = "\nTHE COURTYARD\nThe courtyard is surrounded by six huts, including your own. Stumbling in the blinding haze, you fall over a lifeless body. The hands are familiar, but not the face."

fieldsDescript = "\nTHE PADDY FIELDS\nThe evening is flushed orange by the setting sun. Fresh green paddy, rolls lightly in the breeze. For a moment, as you step into the clayey soil, the world is at peace."



################################################################################
#MEMORIES
################################################################################
#DICTIONARY FOR TATOO MEMORIES
aTattoo = "\nYou had insisted on a tattoo, after watching a shirtless US soldier flaunt one of his. It may hurt, mom had said. But you flexed your non-existent biceps at her.\n\n'What do you want for a tatoo?'\n'Granny's patterns!'"

bTattoo = "\n'These marks on your back, so beautiful'\nTurning your head, you see where she pointed.\n\n'I don't understand all the signs, but I can read some'.\nShe followed the groove on your shoulders with her finger. It made a spiral. An 'Elephant's Foot'.\n\n'This is the elephant's foot', you inform innocently.\nThe finger traveled to the base of your back.\n'And this?\n'Umm, dunno'\n\nThe finger carried on, 'And ---'\n'Stop! Such a mad girl!'\n\nLaughing, she had run away. Before you could catch her, your mother had called you inside for dinner."

#DICTIONARY FOR MOTHER/STORYCLOTH MEMORIES
aMother = "\n'Mother, how do you know how to make a story cloth?'\n'Your granny taught me. She was Hmong. I grew up in the mountains.'\n\nThat explained it. Why she looked different, and had an accent unlike your father's."

#DICTIONARY FOR PEOPLE
#PARENTS
parents = "\nOriginally from south-west Vietnam, your parents were evacuated by US soldiers when bombing operations scourged enemy along the Ho Chi Minh Trail. They were eventually relocated in Long Tan, near the south-east coastal city of Vung Tau."

################################################################################
#ROOMS
#-----------------------------------------------------------------------------
#ROOM_1 ---> HIDING IN THE WICKER BASKET
#-----------------------------------------------------------------------------
def hideInBasket():
	
	
	print hideInBasketDescript
	#story branches here. 
	def query():
		inp = raw_input("\n\tA: You attack the VietCong\n\tB: You watch, powerless.\n\n\tEnter A or B --> ")
	
		if inp.lower() == "a":
			print endline
			print "\nYou burst forth with tears of anger, revealing yourself from the basket. Being young, and possessing not much weapons other than a the fist, your death is inevitable in the ensuing VietCong firing."
			def endquestion():
				print endline
				print "1: RESTORE FROM DEATH? \n2: START FROM BEGINING?\n3: QUIT GAME?"
				input = int(raw_input("--> "))
				if input ==1:
					query()
				elif input ==2:
					startgame()
				else:
					over()
			endquestion()
	
		elif inp.lower() == "b":
			print endline
			print "\nNails dig deeper into your clenched fists. Anger is mixed with stark fear. Suddenly, as if on impulse, the men shoot out aimlessly at everyhthing..."
		
		elif inp.lower() =="help":
			help()
			query()
			
		elif inp.lower() =="history":
			history()
			query()
			
		else: 
			print "Enter A or B"
			query()
			
		
	query()
	#random event generator. story branches here.
	roll = random.randint(0,9)
	hit = [3,4,7,0]
	miss = [1,2,5,6,8,9]
		
	for number in miss:
		if roll == number:
			print "\nWhen they're satisfied, they are talking amongst themselves.\n\t'I guess all clear'\n\t'Yeah, there's no one here'\n\t'Okay, next hut'.\n\nThey leave to track more local spies."
				
			break
		
	for number in hit:
		if roll == number:
			print "\nThe bullets hit the basket, which splits on impact. Fortunaley, they zip past you, but not before taking your left ear. You are revealed, sprawled and bleeding.\n\n'They hid you in that piece of bamboo?'\nYou look up, tense and speechless.\n'What do we do with him?'\n'Kill him, bloody son of ass-lickers!'\n\nOne of the men squats down and considers your face. Then he moves back and lifts your shirt. The SIGNS are uncovered."
			
			#story response for user input
			def sign():
				input = raw_input("--> ")
				if input.lower() == "examine signs":
						
					print aTattoo
					print "\n\n'He seems to be a Hmong'\nWho'd mark him like this? - so... american'\n\nYou remember your mother while the men talk."
					
				elif input.lower() == "help":
					help()
					sign()
					
				elif input.lower() =="history":
					history()
					sign()
				
				else:
					print "enter 'examine signs'"
					sign()
			
			sign()
					
			def recogniseMother():
				input = raw_input("--> ")
				if input == "mother":
					print aMother
					print "\n\nThe men are staring hard at you. You cry silently, as they lose patience.\n\n'This is a waste of time. Lets fins out.'\n\nOne of them scoops you roughly and out of the hut. Through the haze of fire, you can't see much, but then you are thrust down beside a dead figure. The face was an unrecognizable lump of flesh, leaking out of a crack skull. But for you --\n\n'Is she your mother?'"
				
				elif input.lower() == "help":
					help()
					recognisemother()
					
				elif input.lower() =="history":
					history()
					recognisemother()
				
				else:
					print "enter 'mother'"
					recogniseMother()
			
			recogniseMother()
			
			#story branches here.
			def affirmdeny():
				inp = raw_input("\n\tA: nod your head to affirm\n\tB: shake your head to deny.\n\n\tEnter A or B --> ")
						
				if inp.lower() == "a":
					print "\n-- it is your mother.\n'Kill him.'"
					def endquestion():
						print endline
						print "1: RESTORE FROM DEATH? \n2: START FROM BEGINING?\n3: QUIT GAME?"
						input = int(raw_input("--> "))
						if input ==1:
							affirmdeny()
						elif input ==2:
							startgame()
						else:
							over()
					endquestion()
						
				elif inp.lower() == "b":
					print "\n'Take him'\n\n-- That was definitely not your mother. That face wasn't your mother. Surely not as you knew her. You resist the urge to retch. The men bind your hands and hit you hard across the face. \n\nYou pass out."
					#JUMP TO insideTunnel()
					over()
			
				elif inp.lower() == "help":
					help()
					affirmdeny()
				
				elif inp.lower() == "history":
					history()
					affirmdeny()
					
			affirmdeny()
				
				
						
#-----------------------------------------------------------------------------
#ROOM_2 ---> ALONE IN THE VILLAGE HUT
#-----------------------------------------------------------------------------
def homeAlone():
	print homeAloneDescript
	
	def thinkaboutparents():
		input = raw_input("--> ")
		if input.lower() == "think about parents":
			print endline
			print parents
		
		elif input.lower() == "help":
			help()
			thinkaboutparents()
		
		elif input.lower() == "history":
			history()
			thinkaboutparents()
			
		else:
			print "enter 'think about parents'"
			thinkaboutparents()
	
	thinkaboutparents()
	
	print "\nA bomb explodes"
	
	def listentobomb():
		input = raw_input("--> ")
		
		if input.lower() == "hear bomb":
			print endline
			print "The ground reverberates. The hut catches fire." 
		
		elif input.lower == "help":
			help()
			listentobomb()
		
		elif input.lower == "history":
			history()
			listentobomb()
			
		else:
			print "enter 'hear bomb'"
			listentobomb()
	
	listentobomb()
	print "\nThrowing away the basket, you give one last look your thatch hut. Stuff is broken, torn and tossed over. Proud charcoal embers burn oblivious of the inferno. Few Bahn Tet (rice cakes) lie nearby. \n\nYou face the main door, which opens west, towards the paddy fields."
	
	def takestuff():
		input = raw_input("--> ")
		value = input.lower()
		if value == "take banh tet":
			print endline
			print "Taken.\nGrabbing the Bahn Tet, you run out into the coutryard."
		
		elif value == "take rice cakes":
			print endline
			print "Taken.\nGrabbing the Bahn Tet, you run out into the coutryard."
			
		elif value == "basket":
			print endline
			print "Do you need the basket? maybe not, since it was huge and conspicuous. You grab the Bahn Tet and run out into the courtyard."
				
		elif value == "west":
			print endline
			print "Grabbing the Bahn Tet, you run out into the coutryard."
		
		elif value == "help":
			help()
			takestuff()
		
		elif value == "history":
			help()
			takestuff()
			
		else:
			print "Try: 'take banh tet' or 'take rice cakes' or 'west'"
			takestuff()
	
	takestuff()

#-----------------------------------------------------------------------------
#ROOM_3 ---> THE COURTYARD
#-----------------------------------------------------------------------------
endstatement = "Your mother is alive. Lying amidst the heap of dead. Her strength is fast fading. She passes on a handkerchief upon her death. A storycloth.\n\nThrough the thick haze, by the blood soaked mud path, over pulped remains of village kin, you run away from a charred home. And reach the paddy fields."

def courtyard():
	print courtyardDescript
	
	def girl():
		inp = raw_input("\n\tA: you remember the hands\n\tB: you study the face\n\n\tEnter A or B --> ")
		
		if inp.lower() == "a":
			print endline
			print bTattoo
			print endline
			space()
			
			if input == " ":
				print endstatement
			else:
				print endstatement
							
		elif inp.lower() == "b":
			print endline
			print "\nAn unrecognizable lump of flesh leaking from a cracked skull. Staggered, you get on your feet - and face the mud elevation where your parents had fallen."
			
			print endstatement
		
		elif inp.lower() == "help":
			help()
			girl()
		
		elif inp.lower() == "history":
			history()
			girl()
		
		else:
			girl()
	
	girl()

#-----------------------------------------------------------------------------
#ROOM_3 ---> PADDY FIELDS
#-----------------------------------------------------------------------------
def fields():
	print fieldsDescript
	
	def direction():
		inp = raw_input("--> ")
		
		if inp.lower() == "north":
			print "If the news is true, the battle of Long Tan is raging in the rubber plantations up north. Ergo, the Viet Cong were scanning your village."
			direction ()
		
		elif inp.lower() == "south":
			print endline
			print "You rush further into the generously irrigated fields. Inevitably, your balance is lost, slapping you face down into the water."
			
		elif inp.lower() == "east":
			print "Back to your ashen village? uh-oh."
			direction()
		
		elif inp.lower() =="west":
			print endline
			print "You rush further into the generously irrigated fields. Inevitably, your balance is lost, slapping you face down into the water."
		
		elif inp.lower() == "history":
			history()
			direction()
		
		elif inp.lower() == "help":
			help()
			direction()
		
		else:
			print "type 'north' or 'south' or 'east' or 'west'"
			direction()
			
		
	def inpaddy():
		inp = raw_input("\n\tA: uh-oh, helicopters\n\tB: something ticklish in the water\n\tC: something soft in the water \n\n\tEnter A, B or C --> ")
		
		if inp.lower() == "a":
			print endline
			print "Two sky cranes are headed towards the rubber plantation. Most decidedly carrying equipment and supplies for a battle. Seemingly, the only person in the paddy fields, you fall in direct view of the 'copter crew. You wonder in which direction to run."
			direction()
			
		elif inp.lower() == "b":
			print endline
			print "A snake slithers past your leg. Yup, It does bite you. Frothing at the mouth, you die a slow and painful death."
			def endquestion():
				print endline
				print "1: RESTORE FROM DEATH? \n2: START FROM BEGINING?\n3: QUIT GAME?"
				input = int(raw_input("--> "))
				if input ==1:
					inpaddy()
				elif input ==2:
					startgame()
				else:
					over()
			endquestion()
			
		elif inp.lower() == "c":
			print endline
			print "You lose balance, slapping face down into the water."
			
		elif inp.lower() == "help":
			help()
			inpaddy()
			
		elif inp.lower() == "history":
			history()
			inpaddy
			
		else:
			print "Enter A, B or C"
			inpaddy()
	
	inpaddy()
			
	print "\nNearly submerged, the sky is no longer in visible. Only paddy, above and around you. Despite fear, an undeniable presence of something soft disturbs the mind. Mustering the courage to investigate, you turn towards --"
	deadvc = "A dead VietCong. His eyes gape at you. The mouth moves involuntarily. You scream."
	
	moredeadvc = "Over your initial shock, you look closely into the dead man's face. A water scorpion crawls out. You pick it up by the legs and fling it far away. It drops with a 'plop', some distance away.\n\nThe soldier's garb offers a belt , with a pouch slid through it. His pockets reveal a machete and a flashlight. Your hands eagerly feel for his boots benath the muddy water. Instead, you find a water bottle. Its empty."
	
	space()
	if input == " ":
		print endline
		print deadvc
	else:
		print endline
		print deadvc
		
	space()
	if input == " ":
		print endline
		print moredeadvc
	else:
		print endline
		print moredeadvc
		
	

		
		
